import java.net.*;
import java.io.*;
import java.lang.*;

public class Router {
    public static void main(String[] args) throws IOException {

        ServerSocket sSock = null;
        try {
            sSock = new ServerSocket(Integer.parseInt(args[0]));
        } catch (IOException e) {
            System.err.println("Could not listen on port: "+args[0]);
            System.exit(1);
        }

        ServerSocket cSock = null;
        try {
        	cSock = new ServerSocket(Integer.parseInt(args[1]));
        } catch (IOException e) {
            System.err.println("Could not listen on port: "+args[1]);
            System.exit(1);
        }
        
        Socket sockone = null;
        try {
        	sockone = sSock.accept();
        } catch (IOException e) {
        	System.err.println("First Socket Accept() failed.");
        	System.exit(1);
        }
        
        Socket socktwo = null;
        try {
        	socktwo = cSock.accept();
        } catch (IOException e) {
        	System.err.println("Second Socket Accept() failed.");
        	System.exit(1);
        }
        
		byte buf[] = new byte[1024];
		int len; 
		InputStream inone = sockone.getInputStream();
		OutputStream outone = sockone.getOutputStream();
		InputStream intwo = socktwo.getInputStream();
		OutputStream outtwo = socktwo.getOutputStream();
		
		while (true) {
			
			try {
				
				if (sockone.isClosed() || socktwo.isClosed()) {
					System.exit(0);
					}
					
				if ((len = inone.available()) > 0) {
					inone.read(buf,0,len);
					outtwo.write(buf,0,len);
					System.out.println("sent " + len + " bytes from server to client");
				}
				
				if ((len = intwo.available()) > 0) {
					intwo.read(buf,0,len);
					outone.write(buf,0,len);
					System.out.println("sent " + len + " bytes from client to server");
				}
	        } catch (IOException e) {	    
        	// Connection may have been closed
        		System.out.println("some stupid exception!!!");
        	}
		}       	
    }
	
}
